//*****************************************************************************
//*
//*
//*		RenameProjectDlg.cpp
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	"StdAfx.h"
#include	"RenameProject.h"
#include	"RenameProjectDlg.h"
#include	"AfxUtility.h"
#include	"TextFind.h"
#include	"PathDlg.h"



#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CRenameProjectDlg, CDialog)
	//{{AFX_MSG_MAP(CRenameProjectDlg)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_QUERYDRAGICON()
	ON_WM_SYSCOLORCHANGE()
	ON_BN_CLICKED(IDC_PATH, OnPath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//*****************************************************************************
//*
//*		CRenameProjectDlg Dialogfeld
//*
//*****************************************************************************
CRenameProjectDlg::CRenameProjectDlg(CWnd *pParent)
	: CDialog(CRenameProjectDlg::IDD,pParent)
{
CRegKeys	sKey;

	//{{AFX_DATA_INIT(CRenameProjectDlg)
	m_sPath = _T("");
	m_sProject = _T("");
	m_sNewName = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


	sKey.Open(HKEY_CURRENT_USER,"Software\\Microsoft\\DevStudio\\6.0\\Directories");
	sKey.Get(m_sPath,"WorkspaceDir");
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CRenameProjectDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRenameProjectDlg)
	DDX_Text(pDX, IDC_EDIT1, m_sPath);
	DDX_Text(pDX, IDC_EDIT2, m_sProject);
	DDX_Text(pDX, IDC_EDIT3, m_sNewName);
	//}}AFX_DATA_MAP
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CRenameProjectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetButtonBitmap(this,IDC_PATH,IDB_OPEN);
	SubclassEdit(this,IDC_EDIT1,SCE_DROPFILE);

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden


	return TRUE;
}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CRenameProjectDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CRenameProjectDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void CRenameProjectDlg::OnPath()
{
CPathDlg	sDlg;

	UpdateData();

	   sDlg.SetPath(m_sPath);
	if(sDlg.DoModal()!=IDOK)return;

	m_sPath=sDlg.GetPath();

	UpdateData(FALSE);

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CRenameProjectDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CRenameProjectDlg::OnOK()
{
char			cLine[1024];
char			cTemp[16];
CString			sTemp;
CString			sPath;
CString			sText;
CTextFind		sFind;
CFileFinder		sSuche;
CStringChain	sGuids;
CStringChain	sChange;
CString			sUpper;
CString			sLower;
CString			sPrjLwr;
CString			sPrjUpr;
CTextBuffer		sIn,sOut;
CMapFile		sMap;
char		   *pPtr;
FILE		   *pFile;
int				iLower;
int				iSizeNew;
int				iUpper;
int				iItem;
int				iSize;
int				iAdd;
int				iPos;
int				iLen;
int				iAnz;
int				iMax;
int				iOk;
int				i;


	UpdateData();
	DelBackSlash(m_sPath);

	if(m_sProject=="")
		{
		MessageBox("Es ist kein Projektname angegeben !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(m_sNewName=="")
		{
		MessageBox("Es ist kein neuer Projektname angegeben !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(ExistFile(m_sPath)<2)
		{
		MessageBox("Der angegebene Pfad existiert nicht !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	   sSuche.Read(m_sPath,CFF_FIND_SUBDIR|CFF_FIND_ALL,"*.dsw;*.dsp;*.sln;*.vcproj;*.vcxproj;*.uvproj;*.uvprojx;*.ewp;*.eww");
	if(sSuche.Count()==0)
		{
		MessageBox("Es wurden keine Projektdateien gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	   sFind.Find(&sSuche,m_sProject,CTF_WORD);
	if(sFind.Count()==0)
		{
		MessageBox("Der Projektname wurde in den Projektdateien nicht gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

//******************** Projekt Dateien ndern *********************************


	sSuche.Read(m_sPath,CFF_FIND_SUBDIR|CFF_FIND_ALL,"*.vcproj;*.vcxproj");

	
	for(i=0;i<sSuche.Count();i++)					// GUID's in Projektdateien suchen
		{
		
		pPtr = sSuche.Name(i,1);

			pFile = fopen(pPtr,"rb");
		if(!pFile)continue;

		cLine[sizeof(cLine)-1] = 0;

		while(fgets(cLine,sizeof(cLine)-1,pFile))
			{
			iPos = strifind(cLine,"<ProjectGuid>");
			if(iPos<0)continue;
			
			iPos += 13;
			iPos += strwlen(cLine+iPos,0xE0);

			if(cLine[iPos]!='{')continue;

			iPos += 1;
			iPos += strwlen(cLine+iPos,0xE0);

			if(strwlen(cLine+iPos,0x07)!=8)continue;
			if(cLine[iPos+8]!='-')continue;
			if(sGuids.Find(9,cLine+iPos)>=0)continue;

			sGuids.Add(9,cLine+iPos);
			sprintf(cTemp,"%08X-",(unsigned)time(0)^strtoh(cLine+iPos));
			sChange.Add(9,cTemp);
			}
		

		fclose(pFile);
		}					




	sSuche.Read(m_sPath,CFF_FIND_SUBDIR|CFF_FIND_ALL,"*.c;*.cpp;*.h;*.hpp;*.rc;*.hm;*.hh;*.inl;*.rc2;*.dsp;*.dsw;*.sln;*.vcproj;*.vcxproj;*.vcxproj.filters;*.uvprojx;*.clw;Makefile;*.uvprojx;*.ewp;*.eww");

	for(i=0;i<sSuche.Count();i++)					// Alle Dateien durchlaufen
		{
		pPtr = sSuche.Name(i,1);

		SetFileAttributes(pPtr,FILE_ATTRIBUTE_NORMAL);

		if(!sIn.Open(pPtr))
			{
			sText.Format("Fehler beim ffnen von:\n%s",pPtr);
			iOk=MessageBox(sText,"Fehler",MB_OKCANCEL|MB_ICONERROR);
			if(iOk!=IDOK)
				{
				SetCursor(IDC_ARROW);
				return;
				}
			continue;
			}

		sOut.OpenMem();
		iLen=m_sProject.GetLength();
		iItem=-1;
		iAdd=0;
		iAnz=0;

		sPrjUpr = m_sProject;
		sPrjLwr	= m_sProject;
		sPrjUpr.MakeUpper();
		sPrjLwr.MakeLower();

		sUpper=m_sNewName;
		sLower=m_sNewName;
		sUpper.MakeUpper();
		sLower.MakeLower();

		iSize    = m_sProject.GetLength();
		iSizeNew = m_sNewName.GetLength();


		while(sIn.Text(iAdd,&pPtr))					// Alle Zeilen durchsuchen
			{
			iAdd=sIn.TextLineLen();
			iMax=iAdd;

			while(iMax>0)
				{
				iUpper=0;
				iLower=0;
				iItem=-1;
						   iPos=strlfind(pPtr,m_sProject,iMax);
				if(iPos<0){iPos=strlfind(pPtr,sPrjUpr   ,iMax);if(iPos>=0)iUpper=1;}
				if(iPos<0){iPos=strlfind(pPtr,sPrjLwr   ,iMax);if(iPos>=0)iLower=1;}
				if(iPos<0)
					{
					for(iItem=sGuids.Count()-1;iItem>=0;iItem--)
						{
						iPos = strlfind(pPtr,sGuids[iItem],iMax);
						if(iPos>=0)break;
						}

					if(iItem<0)break;
					}

				sOut.Write(pPtr,iPos);

					 if(iItem>=0)sOut.Write(sChange[iItem],sChange.Len(iItem));
				else if(iUpper  )sOut.Write(sUpper    ,iSizeNew);
				else if(iLower  )sOut.Write(sLower    ,iSizeNew);
				else       	     sOut.Write(m_sNewName,iSizeNew);

				iAnz++;
				pPtr+=iPos+iSize;
				iMax-=iPos+iSize;
				}

			sOut.Write(pPtr,iMax);
			}

		sIn.Close();

		if(iAnz)									// Wurden #include	gefunden ?
			{
			pPtr  = sSuche.Name(i,1);
			SetFileAttributes(pPtr,FILE_ATTRIBUTE_NORMAL);

				pFile = fopen(pPtr,"wb");
			if(!pFile)
				{
				sOut.Close();
				sText.Format("Fehler beim ffnen von:\n%s",pPtr);
				iOk=MessageBox(sText,"Fehler",MB_OKCANCEL|MB_ICONERROR);
				if(iOk!=IDOK)return;
				continue;
				}

			pPtr=sOut.Buffer();
			fwrite(pPtr,sOut.GetLength(),1,pFile);
			fclose(pFile);
			delete pPtr;
			}

		sOut.Close();
		}

//******************** Dateinamen umbenennen ***********************************


	sTemp  = m_sProject;
	sTemp += "*";

	sSuche.Read(m_sPath,CFF_FIND_SUBDIR|CFF_FIND_DIR|CFF_FIND_ALL,sTemp);

	for(i=sSuche.Count()-1;i>=0;i--)				// Verzeichnise umbenennen
		{
		pPtr  = sSuche.Name(i,1);
		sPath = pPtr;

		SetFileAttributes(pPtr,FILE_ATTRIBUTE_NORMAL);
		SubFileName(sPath);
		AddBackSlash(sPath);
		sPath+=m_sNewName;
		sPath+=GetFileName(pPtr)+m_sProject.GetLength();

		if(!MoveFile(pPtr,sPath))
			{
			sText.Format("Fehler beim Umbenennen von:\n%s\nin\n%s",pPtr,(LPCSTR)sPath);
			iOk=MessageBox(sText,"Fehler",MB_OKCANCEL|MB_ICONERROR);
			if(iOk!=IDOK)
				{
				SetCursor(IDC_ARROW);
				return;
				}
			}
		}



	sTemp  = m_sProject;
	sTemp += "*";

	sSuche.Read(m_sPath,CFF_FIND_SUBDIR|CFF_FIND_ALL,sTemp);

	for(i=0;i<sSuche.Count();i++)					// Verzeichnis
		{
		pPtr  = sSuche.Name(i,1);
		sPath = pPtr;

		SetFileAttributes(pPtr,FILE_ATTRIBUTE_NORMAL);
		SubFileName(sPath);
		AddBackSlash(sPath);
		sPath+=m_sNewName;
		sPath+=GetFileName(pPtr)+m_sProject.GetLength();

		if(!MoveFile(pPtr,sPath))
			{
			sText.Format("Fehler beim Umbenennen von:\n%s\nin\n%s",pPtr,(LPCSTR)sPath);
			iOk=MessageBox(sText,"Fehler",MB_OKCANCEL|MB_ICONERROR);
			if(iOk!=IDOK)
				{
				SetCursor(IDC_ARROW);
				return;
				}
			}
		}

	sTemp = GetFileName(m_sPath);
	if(sTemp==m_sProject)							// Project Verzeichnis umbenennen
		{
		sTemp=m_sPath;
		SetFileName(sTemp,m_sNewName);
		if(!MoveFile(m_sPath,sTemp))
			{
			SetCursor(IDC_ARROW);
			sText.Format("Fehler beim Umbenennen von:\n%s\nin\n%s",(LPCSTR)m_sPath,(LPCSTR)sTemp);
			MessageBox(sText,"Fehler",MB_OK|MB_ICONERROR);
			return;
			}
		}


	SetCursor(IDC_ARROW);
	MessageBox("Das Projekt wurde umbennand.","Info",MB_OK|MB_ICONINFORMATION);

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CRenameProjectDlg::OnDestroy()
{
	CDialog::OnDestroy();

	DelButtonBitmap(this,IDC_PATH);

}

//*****************************************************************************
//*
//*		OnSysColorChange
//*
//*****************************************************************************
void CRenameProjectDlg::OnSysColorChange()
{

	CDialog::OnSysColorChange();

	DelButtonBitmap(this,IDC_PATH);

	SetButtonBitmap(this,IDC_PATH,IDB_OPEN);

}
